import 'package:flutter/material.dart';
import 'package:test_sa/extensions/context_extension.dart';
import 'package:test_sa/extensions/int_extensions.dart';
import 'package:test_sa/extensions/widget_extensions.dart';
import 'package:test_sa/models/all_requests_and_count_model.dart';
import 'package:test_sa/models/new_models/dashboard_detail.dart';
import 'package:test_sa/modules/pm_module/recurrent_wo/recurrent_work_order_view.dart';
import 'package:test_sa/new_views/app_style/app_color.dart';
import 'package:test_sa/views/widgets/item_views/info_date_widget.dart';
import 'package:test_sa/views/widgets/item_views/info_header_widget.dart';
import 'package:test_sa/views/widgets/item_views/info_text_widget.dart';
import 'package:test_sa/views/widgets/requests/request_status.dart';

class RecurrentWoItemView extends StatelessWidget {
  final Data? requestData;
  final RequestsDetails? requestDetails;
  final bool showShadow;

  const RecurrentWoItemView({Key? key, this.requestData, this.requestDetails, this.showShadow = true}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    if (requestData != null) {
      return Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Row(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              StatusLabel(
                label: requestData!.priorityName!,
                textColor: AppColor.getRequestStatusTextColorByName(context, requestData!.priorityName!),
                backgroundColor: AppColor.getRequestStatusColorByName(context, requestData!.priorityName!),
              ),
              8.width,
              StatusLabel(
                label: requestData!.statusName!,
                textColor: AppColor.getRequestStatusTextColorByName(context, requestData!.statusName!),
                backgroundColor: AppColor.getRequestStatusColorByName(context, requestData!.statusName!),
              ),
              1.width.expanded,
              InfoDateWidget(requestData!.transactionDate ?? ""),
            ],
          ),
          InfoHeaderWidget(requestData?.typeTransaction ?? context.translation.recurrentWo),
          InfoTextWidget(label: context.translation.taskNo, value: requestData!.requestNo),
          InfoTextWidget(label: context.translation.taskNo, value: requestData!.requestNo),
          if (requestData?.siteName != null) InfoTextWidget(label: context.translation.site, value: requestData!.siteName),
          if (requestData!.buildingName != null) InfoTextWidget(label: context.translation.building, value: requestData!.buildingName),
          if (requestData!.departmentName != null) InfoTextWidget(label: context.translation.department, value: requestData!.departmentName),
          if (requestData!.floorName != null) InfoTextWidget(label: context.translation.floor, value: requestData!.floorName),
          if (requestData!.roomName != null) InfoTextWidget(label: context.translation.room, value: requestData!.roomName, showArrow: true),
        ],
      ).toShadowContainer(context, withShadow: showShadow).onPress(() {
        Navigator.of(context).push(MaterialPageRoute(builder: (_) => RecurrentWorkOrderView(taskId: requestData!.id)));
      });
    }
    if (requestDetails != null) {
      return Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        spacing: 1,
        children: [
          Row(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              StatusLabel(
                label: requestDetails!.priority!,
                textColor: AppColor.getRequestStatusTextColorByName(context, requestDetails!.priority!),
                backgroundColor: AppColor.getRequestStatusColorByName(context, requestDetails!.priority!),
              ),
              8.width,
              StatusLabel(
                label: requestDetails!.status!,
                textColor: AppColor.getRequestStatusTextColorByName(context, requestDetails!.status!),
                backgroundColor: AppColor.getRequestStatusColorByName(context, requestDetails!.status!),
              ),
              1.width.expanded,
              InfoDateWidget(requestDetails!.date ?? ""),
            ],
          ),
          InfoHeaderWidget(requestDetails?.nameOfType ?? context.translation.recurrentWo),
          InfoTextWidget(
            label: context.translation.taskNo,
            value: requestDetails!.requestNo,
          ),
          if (requestDetails!.siteName != null) InfoTextWidget(label: context.translation.site, value: requestDetails!.siteName),
          if (requestDetails!.buildingName != null) InfoTextWidget(label: context.translation.building, value: requestDetails!.buildingName),
          if (requestDetails!.departmentName != null) InfoTextWidget(label: context.translation.department, value: requestDetails!.departmentName),
          if (requestDetails!.floorName != null) InfoTextWidget(label: context.translation.floor, value: requestDetails!.floorName),
          if (requestDetails!.roomName != null) InfoTextWidget(label: context.translation.room, value: requestDetails!.roomName, showArrow: true),
        ],
      ).toShadowContainer(context, withShadow: showShadow).onPress(() async {
        Navigator.of(context).push(MaterialPageRoute(builder: (_) => RecurrentWorkOrderView(taskId: requestDetails!.id)));
      });
    }
    return const SizedBox();
  }
}
